<template>
  <v-container>
    <v-card>
      <v-card-title>Add Items</v-card-title>
      <v-card-text>
        <v-row>
          <v-col>
            <v-text-field v-model="state.name" label="Name"> </v-text-field
          ></v-col>
          <v-col>
            <v-text-field
              v-model="state.description"
              label="Description"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-btn @click="addObject">Create</v-btn>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="6">
            <ItemsList :items="state.items" @item-removed="getObjects" />
          </v-col>
          <v-col cols="6">
            <ItemView />
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import { defineComponent, onMounted, reactive } from "@vue/composition-api";
import ItemsList from "@/components/ItemsList.vue";
import ItemView from "@/components/ItemView.vue";
import ItemService from "@/services/ItemService";
import Item from "@/models/Item";

export default defineComponent({
  name: "Items",
  setup() {
    const itemService = new ItemService();
    const state = reactive({
      name: "",
      description: "",
      items: {} as Item[],
    });

    function refreshInputsData() {
      state.name = "";
      state.description = "";
    }

    async function getObjects(): Promise<Item[]> {
      state.items = await itemService.getItems();
      return state.items;
    }

    async function addObject(): Promise<void> {
      const obj: Item = {
        id: 0,
        name: state.name,
        description: state.description,
      };

      const response = await itemService.addItem(obj);

      if (response) {
        refreshInputsData();
        getObjects();
      }
    }

    function clearLocalObjects(): void {
      state.items = {} as Item[];
    }

    onMounted(() => {
      getObjects();
    });

    return {
      getObjects,
      clearLocalObjects,
      state,
      addObject,
    };
  },
  components: {
    ItemsList,
    ItemView,
  },
});
</script>
